
%This program computes the relationship between epsilon (persistence parameter) in the transition matrix and coefficient
%of correlation of r, computed through simulations for two separate cases of the transition matrix and
%the state space for returns, one benchmark, and another used in robustness checks.

%clc
%clear all

brmat=[0.08 0.12 0.15 0.32];%return space
brmat=[0.065 0.12 0.15 0.27];


rstateN=length(brmat);

bequsimuNumber=400000;
el=100000;


fprintf('%s\n','    epsilon   corr      meanr     stdevr   coeff.of variation');
fprintf('\n');

LoopNumber=1;

epsilon2=0.01;%enters transition matrix for lowest rate of return
epsilon1=0;  %enters transition matrix for intermediate rate of return
%epsilon enters transition matrix for highest  rate of return

for epsilon=0.000:0.01:0.05
%transition matrix    
rprob=[80/100+3*epsilon2 12/100-epsilon2 7/100-epsilon2 1/100-epsilon2;
   80/100-epsilon1 12/100+3*epsilon1 7/100-epsilon1 1/100-epsilon1;
   80/100-epsilon1 12/100-epsilon1 7/100+3*epsilon1 1/100-epsilon1;
   80/100-epsilon 12/100-epsilon 7/100-epsilon 1/100+3*epsilon];%benchmark transition matrix

rprob=[95/100+3*epsilon2 1/100-epsilon2 1/100-epsilon2 3/100-epsilon2;
 95/100-epsilon1 1/100+3*epsilon1 1/100-epsilon1 3/100-epsilon1;
 95/100-epsilon1 1/100-epsilon1 1/100+3*epsilon1 3/100-epsilon1;
  95/100-epsilon 1/100-epsilon 1/100-epsilon 3/100+3*epsilon];% another transition matrix to check robustness




rpaccum=zeros(rstateN,rstateN);
rpaccum(:,1)=rprob(:,1);
for i=2:rstateN
    rpaccum(:,i)=rpaccum(:,i-1)+rprob(:,i);
end

S=rprob^1000;

meanr=brmat*S(1,:)';
sdr=(((brmat-meanr).^2)*S(1,:)')^.5;
coeffvar=sdr/meanr;


rand('state',10*LoopNumber+1);
rshock=rand(1,bequsimuNumber);

rsimu=zeros(1,bequsimuNumber);
rsimu(1,1)=brmat(1,1);
for i=2:bequsimuNumber
    
      accumdf=rpaccum(find(rsimu(1,i-1)==brmat),:);
      rsimu(1,i)=brmat(1,find(rshock(1,i)<=accumdf,1));
    
end

ersimu=rsimu(1,bequsimuNumber-el+1:bequsimuNumber);
lagersimu=rsimu(1,bequsimuNumber-el:bequsimuNumber-1);


corr=mean((ersimu-mean(ersimu)).*(lagersimu-mean(lagersimu)))/(std(ersimu)*std(lagersimu));

fprintf('%10.4f',[epsilon corr  meanr  sdr  coeffvar]);
fprintf('\n');


LoopNumber=LoopNumber+1;

end





