%For the log utility case to check that benchmark parameters satisfying assumptions are reasonable: 
%fix state space for three elements of the return 
%and compute the range for the highest return


%The first 3 states are fixed.
%The last state is unknown.

clc
clear all

rhou=0.04;%discount rate
chai=0.25;%bequest preference parameter
T=45;%life span
b=0.2;%estate tax
zeta=0.15;%capital tax
prob=[0.8 0.12 0.07 0.01]; %probabilities for rate of return

r123=(1-zeta)*[0.08 0.12 0.15];%rate of retutn space


RHS=(exp(rhou*T)+rhou*chai-1)/((1-b)*rhou*chai);

lb=1/((1-zeta)*T)*log(RHS);
 %lower bound


ub=log((RHS-exp(r123*T)*prob(1,1:3)')/prob(1,4))/((1-zeta)*T); %upper bound
fprintf('%s\n','  lower bound  fprintf('%10.4f',[epsilon corr  meanr  sdr  coeffvar]);
fprintf('\n');
upper bound');
fprintf('\n');
fprintf('%10.4f',[lb    ub]);
fprintf('\n');


[lb ub];
